#include <esp_log.h>
#include <esp_netif.h>

#include "sacn.h"
#include "mecha.h"

static const char *TAG = "sacn";
static void sacnFpkt_handler(const char *buf, size_t buf_len);

void sacnFtask(void (*sacn_handler)(const sacnTe131_packet *pkt))
{
    netFmc_listener(sacnFpkt_handler);
}

static void sacnFpkt_handler(const char *buf, size_t buf_len)
{
    // Not actually required but makes for simpler coding
    const sacnTe131_packet *pkt = (const sacnTe131_packet *)buf;
    ESP_LOGI(TAG, "sACN packet received. [universe: %u] [priority: %u] [src: %s]",
             ntohs(pkt->frame.universe), pkt->frame.priority, pkt->frame.source_name);

    ESP_LOGI(TAG, "Channels 1-5: %u %u %u %u %u",
             pkt->dmp.prop_val[0],
             pkt->dmp.prop_val[1],
             pkt->dmp.prop_val[2],
             pkt->dmp.prop_val[3],
             pkt->dmp.prop_val[4]);
}